import { type Static, type TSchema } from '@sinclair/typebox';
import type { ValueError } from '@sinclair/typebox/compiler';
import type { FetchError } from './FetchError.js';
export declare class ValidationError extends Error {
    errors: ValueError[];
    readonly isValidationError = true;
    constructor(errors: ValueError[]);
}
export declare const validatedFetch: ({ endpoint, apiKey }: {
    apiKey: string;
    endpoint: URL;
}, fetchImplementation?: typeof fetch) => <Schema extends TSchema>(params: ({
    resource: string;
} | {
    resource: string;
    payload: Payload;
} | {
    resource: string;
    method: string;
}) & {
    query?: URLSearchParams;
}, schema: Schema) => Promise<{
    error: FetchError | ValidationError;
} | {
    result: Static<Schema>;
}>;
type Payload = {
    /** The content-type of body */
    type: string;
    body: string;
};
export declare const JSONPayload: (payload: Record<string, unknown>) => Payload;
export {};
